/**************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved. *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.test.portal;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.*;
import org.exoplatform.test.portlet.Account.*;
import org.exoplatform.test.portlet.Login.*;
import org.exoplatform.test.portlet.Logout.*;
/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class CustomizationNavigationSuite extends WebUnitSuite {
  public CustomizationNavigationSuite() {
    super("CustomizationNavigationSuite", "Add and edit in the navaigation of the portal") ;
    addWebUnit( CommonUnit.CLICK_EDIT_NAVIGATION_MODE) ;
    addWebUnit(CommonUnit.CLICK_BROWSE_NAV) ;
    //Browse Page
    addWebSuite(new PageBrowseSuite());
    //Show Navigation
    //-----Create TestNode---------------------------   
    addWebUnit(
      new ClickURLLinkUnit("ClickShowNodeHierachy", "Show  the hierachy node").
      setURL("uicomponent=UIToolbarNav&op=showNaviagtion")
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickAddNode(onHomePage)", "Click 'add' on homepage").
      setURL("uicomponent=UINavigationManager&op=addNode&objectId=/").
      addValidator(new ExpectFormIdValidator("pageNodeForm")).
      addValidator(new ExpectTextValidator("Add/Edit Node")) 
    ) ;    
    addWebUnit(
      new SubmitFormUnit("Create'TestNode'", "Create a test node with some properties are default").
      setFormId("pageNodeForm").
      setField("name","TestNode").
      setField("displayName","TestNode").
      setField("xhtmlPageReference","#{client.name}:DefaultPage").
      setField("op","save").
      addValidator(new ExpectLinkWithTextValidator("TestNode"))
    ) ;
    //-----Edit TestNode--------------------
    addWebUnit(
      new ClickURLLinkUnit("ClickOnEditNode", "Click on the edit node button on home's page").
      setURL("uicomponent=UINavigationManager&op=editNode&objectId=/TestNode").
      addValidator(new ExpectFormIdValidator("pageNodeForm")).
      addValidator(new ExpectTextValidator("/TestNode")).
      addValidator(new ExpectTextValidator("system")).
      addValidator(new ExpectTextValidator("#{client.name}"))
    ) ;   
    addWebSuite(new SearchPermissionSuite("pageNodeForm","View",
                          "PhaseId[1].searchGroupForViewPerm","member","user"));    
    addWebSuite(new SearchPermissionSuite("pageNodeForm","Edit",
                                        "PhaseId[1].searchGroupForEditPerm", "*" ,"user"));    
    addWebUnit(
      new SubmitFormUnit("ClickSearchPageReference", "Click search page link").
      setFormId("pageNodeForm").
      setField("op","PhaseId[1].searchXhtmlRefPage").
      addValidator(new ExpectFormIdValidator("searchForm")).
      addValidator(new ExpectTextValidator("owner")) 
    ) ;        
    addWebUnit(
      new ClickURLLinkUnit("Select'testPage'", "Select 'testPage' ").
      setURL("uicomponent=UIPageList&op=select&objectId=#{client.name}:testPage").
      addValidator(new ExpectFormIdValidator("pageNodeForm")).
      addValidator(new ExpectTextValidator("#{client.name}:testPage")) 
    ) ;    
    addWebUnit(
      new SubmitFormUnit("Update TestNode", "Update TestNode").
      setFormId("pageNodeForm").
      setField("displayName","UpdatedTestNode").
      setField("op","save").
      addValidator(new ExpectTextValidator("UpdatedTestNode"))
    ) ;    
    //-----Add FirstNode in to HomePage-------------------
    addWebUnit(
      new ClickURLLinkUnit("ClickAddNode(onHomePage)", "Click 'addNode' on homepage").
      setURL("uicomponent=UINavigationManager&op=addNode&objectId=/").
      addValidator(new ExpectFormIdValidator("pageNodeForm")).
      addValidator(new ExpectTextValidator("Add/Edit Node")) 
    ) ;    
    addWebUnit(
      new SubmitFormUnit("CreateFirstNode", "Fill FirstNode infomation").
      setFormId("pageNodeForm").
      setField("name","FirstNode").
      setField("displayName","FirstNode").
      setField("xhtmlPageReference","#{client.name}:/home/my-portal").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UINavigationManager&op=copy&objectId=/FirstNode"))
    ) ;   
    //-----Copy FirstNode and paste to TestNode----------------
    addWebUnit(
      new ClickURLLinkUnit("CopyFrom'FirstNode'", "Copy first node").
      setURL("uicomponent=UINavigationManager&op=copy&objectId=/FirstNode")
    ) ;    
    addWebUnit(
      new ClickURLLinkUnit("PasteTo'TestNode')", "Paste 'FirstNode' to 'TestNode'").
      setURL("uicomponent=UINavigationManager&op=paste&objectId=/TestNode")        
    ) ;    
    addWebUnit(
      new ClickURLLinkUnit("PasteComplete", "Paste Commplete").
      setURL("uicomponent=UINavigationManager&op=selectNode&objectId=/TestNode").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UINavigationManager&op=addNode&objectId=/TestNode/firstNode"))
    ) ;
    //-----Delete FirstNode-----------
    addWebUnit(
      new ClickURLLinkUnit("DeleteFirstNode", "Delete created FirstNode").
      setURL("uicomponent=UINavigationManager&op=deleteNode&objectId=/FirstNode")      
    ) ;
    //-----Delete TestNode------------
    addWebUnit(
      new ClickURLLinkUnit("DeleteFirstNode", "Delete created FirstNode").
      setURL("uicomponent=UINavigationManager&op=deleteNode&objectId=/TestNode")      
    ) ;        
    
    //Browse Page
    //-----Click on Browse Page
    addWebUnit(
      new ClickURLLinkUnit("ClickOnBrowsePage", "Tell web client click on BrowsePage button").
      setURL("&uicomponent=UIToolbarNav&op=browsePage").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPageList&op=delete&objectId=#{client.name}:testPage"))      
    ) ;                
    //-----Delete testPage
    addWebUnit(
      new ClickURLLinkUnit("DeletetestPage", "Tell web client delete created testPage").
      setURL("uicomponent=UIPageList&op=delete&objectId=#{client.name}:testPage").
      addValidator(new ExpectTextValidator("The page has been deleted successfully"))
    ) ;
    //-----Back to view page-------------    
    addWebUnit(CommonUnit.CLICK_VIEW_MODE) ;       
  }  
  public java.util.List getRequiredSuites() {         
    String[] roles = ["user"] ;    
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;  
  } 
}