/**************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved. *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.test.portal;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.CommonUnit;
import org.exoplatform.test.portlet.Account.*;
import org.exoplatform.test.portlet.Login.*;
import org.exoplatform.test.*;
/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class CustomizationPageSuite extends WebUnitSuite {
  
  public CustomizationPageSuite() {
    super("CutomizePageSuite", "Add and edit in the Page") ;
    addWebUnit(CommonUnit.CLICK_EDIT_PAGE_MODE) ;
    addWebUnit(CommonUnit.CLICK_BROWSE_PAGES) ;
    addWebSuite(new PageBrowseSuite());
    //Browse Page
    //-----Click on Browse Page
    addWebUnit(
      new ClickURLLinkUnit("ClickOnBrowsePage", "Tell web client click on BrowsePage button").
      setURL("&uicomponent=UIToolbarPage&op=browsePage").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPageList&op=delete&objectId=#{client.name}:testPage"))      
    ) ;                    
    //-----Delete testPage
    addWebUnit(
      new ClickURLLinkUnit("DeletetestPage", "Tell web client delete created testPage").
      setURL("uicomponent=UIPageList&op=delete&objectId=#{client.name}:testPage").
      addValidator(new ExpectTextValidator("The page has been deleted successfully"))
    ) ;
    //-----Back to view page-------------    
    addWebUnit(CommonUnit.CLICK_VIEW_MODE) ;    
  }
  public java.util.List getRequiredSuites() {     
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;  
  } 
}
