/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portal;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.condition.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.portlet.Login.*;

/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class PageBrowseSuite extends WebUnitSuite {
  public PageBrowseSuite() {
    super("PageBrowseSuite", "Click browse page and do some action") ;        
    //------------------Create New Page with name is 'testPage'-------------------------
    addWebUnit(
        new ClickURLLinkUnit("ClickNewPage", "Tell web client click 'NewPage' on a page").
        setURL("uicomponent=UIToolbar&op=newPage").
        addValidator(new ExpectFormIdValidator("pageModelForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("Create testPage", "Fill page's information and create this page").
        setFormId("pageModelForm").
        setField("name","testPage").
        setField("template", "blank-page").
        setField("op", "save").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPageList&op=preview&objectId=#{client.name}:testPage")) 
    );            
    //--------------Click Preview on page---------------
    addWebUnit(
        new ClickURLLinkUnit("ClickPreview", "Tell web client click 'Preview' on a page").
        setURL("uicomponent=UIPageList&op=preview&objectId=#{client.name}:testPage").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPagePreviewToolbar&op=view"))
    ) ;
    addWebSuite(new PreviewPageSuite("#{client.name}","testPage")) ;      
    //--------------Return Edit Mode---------------
    addWebUnit(
        new ClickURLLinkUnit("ReturnEditMode", "Tell web client click 'back' on a page").
        setURL("uicomponent=UIToolbar&op=return")        
    ) ;
  }
}