/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portal;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.condition.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;

/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class PreviewPageSuite extends WebUnitSuite {
  public PreviewPageSuite(String owner, String pagename) {
    super("PreviewPageSuite", "Click  preview page and do some action") ;
    
    //--------------Click edit on page's preview------------
    addWebUnit(
        new ClickURLLinkUnit("ClickEditPage", "Tell web client click 'Edit' on page's preview").
        setURL("uicomponent=UIPagePreviewToolbar&op=edit").
        addValidator(new ExpectLinkWithURLValidator("componentId=page&portal:action=editProperty"))
    ) ;
    //--------------Edit page--------------
    addWebSuite( new EditPageSuite()) ;
    //--------------Save change----------
    addWebUnit(
        new ClickURLLinkUnit("ClickSavePage", "Tell web client click 'Save' on page's preview").
        setURL("uicomponent=UIPagePreviewToolbar&op=save").
        addValidator(new ExpectTextValidator("Edited Page"))
    ) ;        
    //--------------View Page----------
    addWebUnit(
        new ClickURLLinkUnit("ClickViewPage", "Tell web client click 'Save' on page's preview").
        setURL("uicomponent=UIPagePreviewToolbar&op=view").
        addValidator(new ExpectNoTextValidator("Edited Page"))
    ) ;
    //--------------Back to page browse----------------
    addWebUnit(
        new ClickURLLinkUnit("BackToPageBrowse", "Tell web client click 'Back' to back page's browse").
        setURL("uicomponent=UIPagePreviewToolbar&op=PhaseId[1].cancel").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPageList&op=preview&objectId=${owner}:${pagename}"))
    ) ;
  }
}