/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portlet.Forum ;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.condition.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.portlet.Account.*;
import org.exoplatform.test.portlet.Login.*;

/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: ForumPortletSuite.java,v 1.3 2004/10/21 15:21:49 tuan08 Exp $
 **/
static public class ForumPortletUserSuite extends WebUnitSuite {
  public ForumPortletUserSuite() {
    super("ForumUserSuite", "Go to forum page and do some basic actions") ;
    goToPage("/Site Map") ;
    addWebUnit(
      new ClickLinkWithText("Site Map", "A forum link and ignore the rest").
      setTextLink("Site Map").
      addCondition(new HaveLinkWithTextCondition("Forum", WebUnitSuite.IGNORE_STATUS))
    ) ;
    goToPage("/Forum") ;
    //==============================user units ======================================
    addWebUnit(
      new ClickLinkWithText("ClickForum", "Click on 'Exo Release News' Forum").
      setTextLink("Exo Release News").
      addValidator(new ExpectImageWithAltTextValidator("new topic"))
    ) ;
    //-----View Topic------------------------------------
    addWebUnit(
      new ClickImageLinkWithAltTextUnit("ClickNewTopic", "Tell the web client click on New Topic").
      setAltText("new topic")
    ) ; 
    //----------Add Topic---------------------------------
    addWebUnit( 
      new SubmitFormUnit("SubmitPostForm", "Tell the web client submit the post").
      setFormId("postForm").
      setField("op","save").
      setField("subject","#{client.name}: eXo Platform").
      setField("message","#{client.name} :  The eXo platform™  software is a powerful Open Source corporate portal and content").
      addValidator(new ExpectImageWithAltTextValidator("reply"))
    ) ;
    addWebUnit(
      new ClickImageLinkWithAltTextUnit("ClickReplyTopic", "Tell the web client click on Reply").
      setAltText("reply")
    ) ; 
    //------------------Reply post ---------------
    addWebUnit(
      new SubmitFormUnit("ReplyPostForm", "Tell the web client submit the post").
      setFormId("postForm").
      setField("op","save").
      setField("subject","#{client.name}").
      setField("message","#{client.name}").
      addValidator(new ExpectImageWithAltTextValidator("reply"))
    ) ;
    //View Forum Page
    addWebUnit(
      new ClickLinkWithText("ClickForum", "Click on 'Exo Release News' Forum").
      setTextLink("Exo Release News").
      addValidator(new ExpectImageWithAltTextValidator("new topic"))
    ) ;
    //  -----Select forum-----------------------------------
    addWebUnit(
      new ClickImageLinkWithAltTextUnit("ClickNewTopic", "Click on New Topic link").
      setAltText("new topic").
      addValidator(new ExpectFormIdValidator("postForm")) 
    ) ; 
    //-----------New Topic---------------------------------
    addWebUnit(
      new SubmitFormUnit("SubmitPostForm", "Tell the web client submit the post").
      setFormId("postForm").
      setField("op","save").
      setField("subject","new subject").
      setField("message","test message").
      addValidator(new ExpectTextValidator("Messages"))
    ) ;
    //----------View Topic--------------------------------
    addWebUnit(
      new ClickLinkWithText("ClickForumTopics", "Click on forum 'Exo Release News' topics").
      setTextLink("Exo Release News").
      addValidator(new ExpectLinkWithTextValidator("new subject"))
    ) ;
    addWebUnit(
      new ClickLinkWithText("ClickViewPost", "Click on forum 'new subject' post").
      setTextLink("new subject").
      addValidator(new ExpectTextValidator("new subject")).
      addValidator(new ExpectLinkWithTextValidator("Exo Release News"))
    ) ;
    //----------ViewPost---------------------------------
    addWebUnit(
      new ClickURLLinkUnit("ClickQuotePost", "Click on the quote post of 'new subject' post").
      setURL("uicomponent=UIPosts&op=quotePost").
      addValidator(new ExpectFormIdValidator("postForm"))
    ) ;
    //---------------Quote Post---------------------------
    addWebUnit(
      new SubmitFormUnit("SubmitQuotePostForm", "Tell the web client submit the post quote").
      setFormId("postForm").
      setField("op","save").
      setField("subject","new subject").
      setField("message","test message edit").
      addValidator(new ExpectTextValidator("test message")).
      addValidator(new ExpectTextValidator("test message edit"))
    ) ;
    //---------ViewPost-------------------------------------
    addWebUnit(
      new ClickURLLinkUnit("ClickEditPost", "Click on the quote post of 'new subject' post").
      setURL("uicomponent=UIPosts&op=editPost").
      addValidator(new ExpectFormIdValidator("postForm")).
      addValidator(new ExpectTextValidator("Add/Edit Post"))
    ) ;
    //---------------Edit Post-------------------------------
    addWebUnit(
      new SubmitFormUnit("SubmitEditPostForm", "Tell the web client submit the post edit").
      setFormId("postForm").
      setField("op","save").
      setField("subject","old subject").
      setField("message","test message edit").
      addValidator(new ExpectTextValidator("old subject")).
      addValidator(new ExpectTextValidator("test message edit"))
    ) ;
    // ----------ViewPost-------------------------------------
    addWebUnit(
      new ClickLinkWithText("ClickForumTopics", "Click on forum 'Exo Release News' topics").
      setTextLink("Exo Release News").
      addValidator(new ExpectLinkWithTextValidator("new subject"))
    ) ;
  }
  
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(),
            new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }
}