package org.exoplatform.test.portlet.Login ;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.unit.NewSessionUnit;
import org.exoplatform.test.web.validator.*;
/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 **/
public class UserLoginSuite extends WebUnitSuite {
  public UserLoginSuite() {
    super("UserLoginSuite",  "Go to the home page and login, using web client name for user name and password") ;
    String[] roles = ["user", "admin"] ;
    init("admin", "exo", roles) ;
  }
  public UserLoginSuite(String userName, String password, String[] roles) {
    super("UserLoginSuite",  "Go to the home page and login, using web client name for user name and password") ;
    init(userName, password, roles) ;
  }
  public void init(String userName, String password, String[] roles) {            
    //Create new session
    addWebUnit(
      new NewSessionUnit("NewSession", "Create new session and go to the home page for the first time")
    );
    //User not registered or invalid password
    addWebUnit(
      new SubmitFormUnit("InvalidAccount", "Login with user name ${userName} and password ${password}").
      setFormId("loginForm").
      setField(userName:userName).
      setField(password:"invalidPassword").
      setField("op", "login").
      addValidator(new ExpectTextValidator("User not registered or invalid password"))     
    );        
    //Username and password is verified
    addWebUnit(
      new SubmitFormUnit("VerifiedAccount", "Login with user name ${userName} and password ${password}").
      setFormId("loginForm").
      setField(userName:userName).
      setField(password:password).
      setField("op", "login").
      addValidator(new ExpectTextValidator("Welcome")).
      addValidator(new ExpectTextValidator(userName))
    );
    for(role in roles) {
      addWebUnit(
        new AddRoleUnit("AddRole: ${role}", "Add user role to the web client").
        setRoleToAdd(role)
      );
    }
  }  
}
