/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portlet.Organization;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.condition.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.portlet.Login.*;
import org.exoplatform.test.portlet.Logout.*;
import org.exoplatform.test.portlet.Account.*;
import org.exoplatform.test.web.unit.NewSessionUnit;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Nov 15, 2005
 */
public class PortalAdminSuite extends WebUnitSuite {
  static String DESC = "Go to Portal Admin page and test all the basic actions" ;
  static String NAME = "PortalAdminSuite" ;
  
  public PortalAdminSuite() {    
    super(NAME, DESC) ;
    init("/Site Map/Portal Admin") ;
  }  
  public PortalAdminSuite(String path) {
    super(NAME, DESC) ;
    init(path) ;
  }  
  public void  init(path) {    	
    //Save admin context
    addWebUnit(
      new ContextManagementUnit(ContextManagementUnit.SAVE, "Save Context")
    );    
    //Create, login with a new account    
	//addWebSuite(new NewAccountSuite()) ;
    String[] roles=["user"];
    addWebSuite(new UserLoginSuite("#{client.name}", "#{client.name}", roles)) ;       
    //Restore admin context 
    addWebUnit(
      new ContextManagementUnit(ContextManagementUnit.RESTORE, "Restore Context")
    );
    //Go to Portal admin
    goToPage(path) ;
    //Search Permision    
    addWebUnit(
      new SubmitFormUnit("SearchPermision", "Click on search link").
      setFormId("searchForm").
      setField("op", "search").
      setField("owner", "#{client.name}").      
      addValidator(new ExpectTextValidator("#{client.name}"))      
    ) ; 
    //Edit
    addWebUnit(
      new ClickURLLinkUnit("ClickOnEdit", "Click on edit").
      setURL("&uicomponent=UIAvailablePortal&op=admin&objectId=#{client.name}").
      addValidator(new ExpectTextValidator("Welcome")).
      addValidator(new ExpectTextValidator("#{client.name}"))
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnBack", "Click on back").
      setURL("admin:returnAction=return").
      addValidator(new ExpectFormIdValidator("searchForm"))      
    ) ;
  }
  public java.util.List getRequiredSuites() { 
  	String[] roles = ["user", "admin"] ;
   	return [new UserLoginSuite("admin", "exo", roles)] ;
  }
}