<%@ page import='javax.jcr.*' %>
<%@ page import='javax.naming.*' %>
<%@ page import='org.exoplatform.container.*' %>
<%@ page import='org.exoplatform.services.jcr.*' %>
<%@ page import='org.exoplatform.services.jcr.impl.core.*' %>

<% 
  BindableRepositoryImpl repository = null;
  Node node = null;
  try {
    InitialContext jndiContext = new InitialContext();
    Context environment = (Context) jndiContext.lookup("java:comp/env");
    repository = (BindableRepositoryImpl)environment.lookup("jcr/repository");
//    repository = (BindableRepositoryImpl)jndiContext.lookup("repository");
    
    Credentials credentials = new SimpleCredentials("exo", "exo".toCharArray());  
    Session jcrSession = repository.login(credentials, "ws");
    node = jcrSession.getRootNode();
  } catch (Exception e) {
    e.printStackTrace();
    System.out.println("!!!ERROR: " + e.toString());
  }
%>

<html>
  <body>
    <table>
      <th>
        <td colspan="2">eXo Platform JCR 1.0 RC-1 Informations</td>
      </th>
      <tr>
        <td>Name</td>
        <td><%= repository.getDescriptor(Repository.REP_NAME_DESC) %></td>
      </tr>
      <tr>
        <td>Vendor</td>
        <td><%= repository.getDescriptor(Repository.REP_VENDOR_DESC) %></td>
      </tr>
      <tr>
        <td>URL</td>
        <td><%= repository.getDescriptor(Repository.REP_VENDOR_URL_DESC) %></td>
      </tr>
      <tr>
        <td>Repository version</td>
        <td><%= repository.getDescriptor(Repository.REP_VERSION_DESC) %></td>
      </tr>
      <tr>
        <td>Spec name</td>
        <td><%= repository.getDescriptor(Repository.SPEC_NAME_DESC) %></td>
      </tr>
      <tr>
        <td>Spec version</td>
        <td><%= repository.getDescriptor(Repository.SPEC_VERSION_DESC) %></td>
      </tr>
      <tr>
        <td>Level 1 supported</td>
        <td><%= repository.getDescriptor(Repository.LEVEL_1_SUPPORTED) %></td>
      </tr>
      <tr>
        <td>Level 2 supported</td>
        <td><%= repository.getDescriptor(Repository.LEVEL_2_SUPPORTED) %></td>
      </tr>
      <tr>
        <td>Observation supported</td>
        <td><%= repository.getDescriptor(Repository.OPTION_OBSERVATION_SUPPORTED) %></td>
      </tr>
      <tr>
        <td>Versioning supported</td>
        <td><%= repository.getDescriptor(Repository.OPTION_VERSIONING_SUPPORTED) %></td>
      </tr>
      <tr>
        <td>Locking supported</td>
        <td><%= repository.getDescriptor(Repository.OPTION_LOCKING_SUPPORTED) %></td>
      </tr>
      <tr>
        <td>Transactions supported</td>
        <td><%= repository.getDescriptor(Repository.OPTION_TRANSACTIONS_SUPPORTED) %></td>
      </tr>      
      <tr>
        <td>Query SQL supported</td>
        <td><%= repository.getDescriptor(Repository.OPTION_QUERY_SQL_SUPPORTED) %></td>
      </tr>      
      <tr>
        <td>Root Path</td>
        <td><%= node.getPath() %></td>
      </tr>
    </table>
  </body>  
</html>