/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.templates.velocity;

import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.RuntimeServices;
import org.apache.velocity.runtime.resource.Resource;
import org.apache.velocity.runtime.resource.loader.ResourceLoader;
import org.exoplatform.container.component.ComponentPlugin;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Apr 19, 2005
 * @version $Id$
 */
abstract public class ResourceLoaderPlugin extends ResourceLoader implements ComponentPlugin {
  String name ;
  String description ;
  
  public String getName() {  return name; }
  public void setName(String s) { name = s; }

  public String getDescription() {  return description; }
  public void setDescription(String s) { description = s; }
  
  public void setRuntimeServices(RuntimeServices rsvc) {
    this.rsvc = rsvc ;
  }
  
  abstract public Resource getResource(String resourceName, 
                                       int resourceType, String encoding )
  throws ResourceNotFoundException, ParseErrorException, Exception ;
  
  abstract public boolean canLoadResource(String s)  ;
}
