/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.faces.core.renderer.html;

import groovy.lang.Writable;
import groovy.text.SimpleTemplateEngine;
import groovy.text.Template;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.servlet.ServletContext;

import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.component.ComponentTemplate ;
import org.exoplatform.faces.core.component.model.Parameter;

public  class GroovyRenderer extends  HtmlBasicRenderer {
  private HashMap cache_ = new HashMap() ;
  ThreadLocal lthread_ = new ThreadLocal() {
    protected synchronized Object initialValue() {  return new JSF(); }
  };
  
  public void encodeChildren( FacesContext context, UIComponent component ) throws IOException {
    //Template tmpl = (Template) cache_.get(component.getClass()) ;
    Template tmpl = null ;
    if(tmpl == null) {
      try {
        String name = null ;
        if(component instanceof  ComponentTemplate) {
          name =  ((ComponentTemplate)component).getTemplatePath() ;
        } else {
          name = component.getClass().getName() ;
          name = name.replaceFirst("component", "renderer/html") ;
          name = name.replace('.', '/') + ".groovy" ;
        }
        ServletContext scontext = (ServletContext) context.getExternalContext().getContext();
        InputStream is = scontext.getResourceAsStream("/groovy/" + name) ;
        InputStreamReader reader = new  InputStreamReader(is) ;
        SimpleTemplateEngine engine = new SimpleTemplateEngine()  ;
        tmpl = engine.createTemplate(reader) ;
        cache_.put(component.getClass(), tmpl) ;
      } catch (Exception ex) {
        ex.printStackTrace() ;
        return ;
      }
      Thread.currentThread().getId() ;
      ResourceBundle res = getApplicationResourceBundle(context.getExternalContext());
      Map binding =  new HashMap() ;
      binding.put(UIExoComponent.UICOMPONENT, component) ;
      binding.put("res", res) ;
      JSF jsf = (JSF)lthread_.get() ;
      jsf.setComponent((UIExoComponent)component) ;
      jsf.setResourceBundle(res) ;
      binding.put("jsf", jsf) ;
      Writable writable = tmpl.make(binding) ;
      writable.writeTo(context.getResponseWriter()) ;
    }
  }
  
  public static class  JSF {
    UIExoComponent uicomponent_ ;
    ResourceBundle res_ ;
    StringBuilder b = new StringBuilder() ;
    
    void  setComponent(UIExoComponent uicomp) {  uicomponent_ = uicomp ; }
    void  setResourceBundle(ResourceBundle res) { res_ = res ; }
    
    public String jsfLink(String label , Parameter[] params) {
      return jsfLink(label , params, null) ;
    }
    
    public String jsfLink(String label , Parameter[] params, String id) {
      b.setLength(0) ;
      b.append("<a  href='");
      b.append(uicomponent_.getBaseURL());
      for (int i = 0; i < params.length; i++) {
        b.append("&amp;").append(params[i].getName()).append('=').append(params[i].getValue());
      }
      if(id != null) {
        b.append("&amp;").append(UIExoComponent.OBJECTID).append("=").append(id);
      }
      b.append("'>");
      if(label == null) label = "??????" ;
      if(label.charAt(0) == '@') {
          label = res_.getString(label) ;
      }
      b.append(label).append("</a>");
      return b.toString() ;
    }
  }
}