package org.exoplatform.velocity.directive;

import java.io.IOException;
import java.io.Writer;
import java.util.ResourceBundle;
import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.RuntimeServices;
import org.apache.velocity.runtime.directive.Directive;
import org.apache.velocity.runtime.parser.node.Node;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.component.UISimpleForm;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since March 3, 2005
 * @version $Id$
 */
public class JSFFormButton extends Directive {
  private String label_ ;
  private boolean useResource_ ;
  
  public String getName()  {    return "jsfFormButton"; }        
  
  public int getType() {  return LINE; }        
  
  public void init(RuntimeServices rs, InternalContextAdapter context, Node node) throws Exception {
    super.init(rs, context, node);
    label_ = (String)node.jjtGetChild(0).value(context);
    if(label_ == null) {
      useResource_ = false ;
      return ;
    }    
    if(label_.startsWith("@")) {
      label_ = label_.substring(1) ;
      useResource_ = true ;
    } else {
      useResource_ = false ;
    }
  }
  
  public boolean render(InternalContextAdapter context,  Writer w, Node node)
  throws IOException,  MethodInvocationException, ResourceNotFoundException, ParseErrorException {
    UISimpleForm uiForm = (UISimpleForm)context.get(UIExoComponent.UICOMPONENT) ;
    String action = (String)node.jjtGetChild(1).value(context);
    String label = (String)node.jjtGetChild(0).value(context);    
    if(useResource_) {
      ResourceBundle res = (ResourceBundle)context.get("res") ;
      label = res.getString(label_) ;
    }
    w.write("<a  href=\"javascript:submitForm('"); w.write(uiForm.getFormName()); w.write("','");
    w.write(action) ; w.write("');\">");
    w.write(label);
    w.write("</a>");
    return true;
  }
}