/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.backup.component;

import java.util.* ;
import java.io.File ;
import org.exoplatform.faces.core.component.*;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.*;
import org.exoplatform.portlets.backup.component.model.ImportData;
import org.exoplatform.services.backup.ImportExportService;

/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIImportData.java,v 1.5 2004/09/21 00:16:11 tuan08 Exp $
 */
public class UIImportData extends UIExoCommand {
  static String IMPORT_DATA = "importData" ;
  static String VIEW_DATA = "viewData" ;
  static String REFRESH_DATA = "refreshData" ;
  static String IMPORT_ALL_DATA = "importAllData" ;
  static String DOWNLOAD_ALL_DATA = "downloadAllData" ;
  
  static Parameter[] IMPORT_PARAMS = { new Parameter(ACTION , IMPORT_DATA )} ;
  static Parameter[] VIEW_PARAMS = { new Parameter(ACTION , VIEW_DATA )} ;
  static Parameter[] REFRESH_PARAMS = { new Parameter(ACTION , REFRESH_DATA )} ;
  static Parameter[] IMPORT_ALL_PARAMS  =   { new Parameter(ACTION , IMPORT_ALL_DATA) } ;
  static Parameter[] DOWNLOAD_ALL_PARAMS  =   { new Parameter(ACTION , DOWNLOAD_ALL_DATA) } ;
  
  protected ImportExportService service_ ;
  protected String directory_ ;
  protected List importDatas_ ;
  protected boolean adminRole_ = false ;

  public UIImportData(ImportExportService service) {
  	setRendererType("VelocityRenderer") ;
  	service_ = service ;
  }
  
  public Parameter[] getImportParams() { return IMPORT_PARAMS ; }
  public Parameter[] getViewParams() { return VIEW_PARAMS ; }
  public Parameter[] getRefreshParams() { return REFRESH_PARAMS ; }
  public Parameter[] getImportAllParams() { return IMPORT_ALL_PARAMS ; }
  public Parameter[] getDownloadAllParams() { return DOWNLOAD_ALL_PARAMS ; }
  
  public boolean hasAdminRole() { return adminRole_ ; }
  public void    setAdminRole(boolean b) { adminRole_ = b ; }
  
  ImportExportService getBackupService() { return service_ ; } 
  
  public String getDirectory() { return directory_ ; }
  public void   setDirectory(String s) { directory_ = s ; }
  
  public List getImportDatas() { return importDatas_ ; }
  
  protected void populateImportData() {
  	File dir = new File(directory_) ;
  	File[] files = dir.listFiles(new ZipFileFilter()) ;
  	importDatas_ = new ArrayList(files.length) ;
  	for(int i = 0; i < files.length; i++) {
  		importDatas_.add(new ImportData(files[i])) ;
  	}
  }
  
  static public class RefreshActionListener extends ExoActionListener  {
  	public void execute(ExoActionEvent event) throws Exception {
      UIImportData ui = (UIImportData) event.getComponent() ;
  		ui.populateImportData() ;
    }
  }
  
  
  static public class ViewDataActionListener extends ExoActionListener  {
  	public void execute(ExoActionEvent event) throws Exception {
      UIImportData ui = (UIImportData) event.getComponent() ;
  		UINode parent = (UINode) ui.getParent() ;
  		UIData uiData = (UIData)  parent.getChildComponentOfType(UIData.class) ;
  		String dataName = event.getParameter(OBJECTID) ;
  		for(int i = 0 ; i < ui.importDatas_.size() ; i++) {
  			ImportData data = (ImportData) ui.importDatas_.get(i) ;
  			if(data.getName().equals(dataName)) {
  				uiData.setImportDataModel(data) ;
  				parent.setRenderedComponent(uiData.getId()) ;
  			}
  		}
    }
  }
}