/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.backup.component;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.context.FacesContextFactory;
import javax.faces.context.ResponseStream;
import javax.faces.context.ResponseWriter;
import javax.portlet.PortletResponse;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.faces.core.event.CheckRoleInterceptor;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.backup.ImportExportService ;

import com.sun.faces.context.FacesContextFactoryImpl;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIImportUserData.java,v 1.8 2004/09/21 00:16:11 tuan08 Exp $
 */
public class UIImportUserData extends UIImportData {
   
  public UIImportUserData(ImportExportService service) {
  	super(service) ;
  	setId("UIImportUserData") ;
    setDirectory(service_.getUserDataDirectory()) ;
  	populateImportData() ;
  	
    addActionListener(RefreshActionListener.class, REFRESH_DATA) ;
    addActionListener(ViewDataActionListener.class, VIEW_DATA) ;
    addActionListener(ImportUserActionListener.class, IMPORT_DATA) ;
    addActionListener(ImportAllActionListener.class, IMPORT_ALL_DATA) ;
    addActionListener(DownloadAllActionListener.class, DOWNLOAD_ALL_DATA) ;
    adminRole_ = hasRole("admin") ;
  }
  
  static public class ImportUserActionListener extends ExoActionListener  {
    public ImportUserActionListener() {
      addInterceptor(new CheckRoleInterceptor("admin")) ;  
    }
    
  	public void execute(ExoActionEvent event) throws Exception {
  	  UIImportUserData component = (UIImportUserData)event.getComponent() ;
  		String dataName = event.getParameter(OBJECTID) ;
  		int idx = dataName.indexOf('.') ;
	    String userName = dataName.substring(0, idx) ;
  		component.getBackupService().importUserData(userName) ;
    }
  }
  
  static public class ImportAllActionListener extends ExoActionListener  {
    public ImportAllActionListener() {
      addInterceptor(new CheckRoleInterceptor("admin")) ;  
    }
    
  	public void execute(ExoActionEvent event) throws Exception {
  	  UIImportUserData component = (UIImportUserData)event.getComponent() ;
  		component.getBackupService().importUserData() ;
    }
  }
  static public class DownloadAllActionListener extends ExoActionListener  {
    public DownloadAllActionListener() {
      addInterceptor(new CheckRoleInterceptor("admin")) ;  
    }
    
    public void execute(ExoActionEvent event) throws Exception {
      System.out.println(" \n\n\n\n\n\n\n\n");      
      UIImportUserData u = (UIImportUserData)event.getComponent();     
      FacesContext ctx = u.getFacesContext();      
      if( !ctx.getResponseComplete() ) {
        try {                  
          HttpServletResponse response =(HttpServletResponse)ctx.getExternalContext().getResponse();
//          DownloadServlet d = new DownloadServlet();
          String output = System.getProperty("java.io.tmpdir")+ File.separator+ "allUser.zip" ;    
//          getRequestContextPath()+"/WEB-INF/files/allUser.zip";
          System.out.println( output);
          u.getBackupService().archiveUserData( output) ;
          response.sendRedirect("/exo-admin/download?file=allUser.zip");
          ctx.responseComplete();
        }catch (Exception e) {         
          e.printStackTrace();
        }
        
      }
//      System.out.println( stream);
     
      System.out.println(" \n\n\n\n\n\n\n\n");
//      UIImportUserData component = (UIImportUserData)event.getComponent() ;
//      component.getBackupService().importUserData() ;
    }
  }
}