/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.resources.component;

import java.util.* ;
import org.exoplatform.faces.core.component.*;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.resources.LocaleConfigService;
import org.exoplatform.services.resources.LocaleConfig ;
/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen 
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UISearchForm.java,v 1.4 2004/06/24 13:35:32 tuan08 Exp $
 */
public class UISearchForm extends UISimpleForm {
  private static String SEARCH_RESOURCE = "searchResource" , NEW_RESOURCE = "newResource";
  private UIStringInput nameInput_ ;
  private UISelectBox   languageInput_ ;
  private boolean adminRole_ = false ; 

  public UISearchForm(boolean adminRole) {
    super("searchForm", "post", null) ;
    setId("UISearchForm");
    setRendererType("SimpleFormVelocityRenderer");
    adminRole_ = adminRole ; 
    LocaleConfigService service =
      (LocaleConfigService) PortalContainer.getComponent(LocaleConfigService.class);
    Iterator i = service.getLocalConfigs().iterator() ;
    List options = new ArrayList() ;
    options.add(new SelectItem("All", ""))  ;
    while (i.hasNext()) {
      LocaleConfig config = (LocaleConfig) i.next() ;
      options.add(new SelectItem(config.getLocaleName(), config.getLanguage()))  ;
    }
    nameInput_ = new UIStringInput("name", "") ;
    languageInput_ = new UISelectBox("language","" , options) ;  
    add(nameInput_) ;
    add(languageInput_) ;
    
    addActionListener(SearchActionListener.class, "searchResource") ;
    addActionListener(NewResourceActionListener.class, "newResource") ;
  }
 
  public boolean getAdminRole() { return adminRole_ ; }
  public String getSearchAction() { return SEARCH_RESOURCE ; }
  public String getNewAction() { return NEW_RESOURCE ; }
  
  static public class SearchActionListener extends ExoActionListener  {
  	public void execute(ExoActionEvent event) throws Exception {
  		UISearchForm uiForm = (UISearchForm) event.getComponent() ; 
  		UIListResources uiListResources = (UIListResources) uiForm.getParent() ;
    	String language = uiForm.languageInput_.getValue();
    	if ("all".equals(language)) language = null ;
    	uiListResources.update(uiForm.nameInput_.getValue(), language);
    }
  }
  
  static public class NewResourceActionListener extends ExoActionListener  {
  	public void execute(ExoActionEvent event) throws Exception {
  		UISearchForm uiForm = (UISearchForm) event.getComponent() ; 
  		UIResourcesPortlet uiPortlet = (UIResourcesPortlet) uiForm.getParent().getParent() ;
    	UIResource uiResource = 
    		(UIResource)uiPortlet.getChildComponentOfType(UIResource.class) ;
    	uiResource.setResourceBundleData(null) ;
      uiResource.setMode(UIResource.EDIT_MODE) ;
    	uiPortlet.setRenderedComponent(uiResource.getId()) ;
    }
  }
}
