package org.exoplatform.portlets.cache.component;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.monitor.component.UIUserActivitiesLogChart.ChartParameter;
import org.exoplatform.services.cache.ExoCache;
import org.exoplatform.services.chart.Chart;
import org.exoplatform.services.chart.ChartService;
import org.exoplatform.services.chart.Data;
/**
 * wen, Aug 10, 2005 @ 13:07:02 
 * @author: Hung Nguyen
 * @email:   nqhungvn@users.sourceforge.net
 * @version: $Id: UIChart.java,v 1.14 2005/08/10 13:07:02 nqhungvn Exp $
 */
public class UICachesChart extends UIExoCommand {
	
	final public static Parameter[] BACK_PARAMS = {new Parameter(ACTION , CANCEL_ACTION) } ;

	private String portal_ ;
  private ChartParameter chartParam_ ;
  ChartService chartService_ ;
  
	public UICachesChart(ChartService chartService) throws Exception {
		setId("UIChart") ;
		setRendererType("VelocityRenderer") ;
    chartService_ =  chartService ;
    chartParam_ = new ChartParameter("null") ;
		addActionListener(BackActionListener.class, CANCEL_ACTION) ;
	}
	
  public Parameter[] getBackParams() { return BACK_PARAMS ; }
  
  public ChartParameter getChartId() {
    ChartParameter chartParamReturn =  chartParam_;
    chartParam_ = new ChartParameter("null") ;
    return chartParamReturn ;         
  }
	
	public String getPortalName() { return portal_ ; }
  
	public void updateDataSet( Collection cacheList ) throws Exception {
		PortalContainer pcontainer =  PortalContainer.getInstance() ;
		ArrayList dataset = new ArrayList();
		Iterator it = cacheList.iterator() ;
		Data data ;
		long cacheHit = 0 ;
		long cacheMiss = 0 ;
    while (it.hasNext()) {
			ExoCache cache = (ExoCache)it.next() ;
      String cacheName = cache.getLabel() ;
			// create chart data
			data = new Data() ;
			data.setValue(cache.getCacheHit()) ;
			data.setSeries("Cache Hit") ;
      data.setType(cacheName) ;
      data.setDisplayColor(Color.RED) ;
      dataset.add(data) ;
			cacheHit += cache.getCacheHit() ;
			data = new Data() ;
			data.setValue(cache.getCacheMiss()) ;
			data.setSeries("Cache Miss") ;
			data.setType(cacheName) ;
      data.setDisplayColor(Color.BLUE) ;
			dataset.add(data) ;
			cacheMiss += cache.getCacheMiss() ;
		}
		// Summary compare data
		data = new Data() ;
		data.setValue(cacheHit) ;
		data.setSeries("Cache Hit") ;
		data.setType("SUMMARY COMPARE") ;
    data.setDisplayColor(Color.RED) ;
		dataset.add(data) ;
		data = new Data() ;
		data.setValue(cacheMiss) ;
		data.setSeries("Cache Miss") ;
		data.setType("SUMMARY COMPARE") ;
    data.setDisplayColor(Color.BLUE) ;
		dataset.add(data) ;
		
		Chart chart = new Chart();
		chart.setChartTitle("eXoplatform Chart Cache");
		chart.setChartType(Chart.COLUMN_CHART);
		chart.setIs3DChart(false);
		chart.setChartWidth(600);
		chart.setChartHeight(400);
		chart.setCategoryLabel("Cache Name");
		chart.setValueLabel("Hits / Miss Values");
		chart.setIsHorizontal(true);
    chart.setIsDisplayItemLabel(true) ;
		chart.setChartData(dataset);
    portal_ = pcontainer.getPortalContainerInfo().getContainerName() ;
		String chartId = chartService_.getChartID(chart) ;
    chartParam_ = new ChartParameter(chartId) ;
    //listChartIdParam_.add(chartParam) ;
	}	
	
  static public class BackActionListener extends ExoActionListener  {
		public void execute(ExoActionEvent event) throws Exception {
			UICachesChart uiChart = (UICachesChart) event.getComponent() ;
			uiChart.setRenderedSibling(uiChart.getSibling(UIListCache.class).getClass()) ; //UIListCache.class
		}
	}  
  
  static public class ChartParameter {
    private String chartId_ ;    
    public ChartParameter(String id){
      chartId_ = id ;
    }
    public String getChartId(){ return chartId_ ; }
  }
}
