/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.log.impl;

import java.util.GregorianCalendar;

import org.exoplatform.services.portal.log.UserActivitiesLogData;

/**
 * Created by The eXo Platform SARL
 * Author : Hung Nguyen
 *          nqhungvn@users.sourceforge.net
 * Sep 26, 2005
 * @hibernate.class  table="USER_ACTIVITIES_LOG_DATA"
 */
public class UserActivitiesLogDataImpl implements UserActivitiesLogData {
  private String userName ;
  private String sessionId ;
  private String portalOwner ;
  private String accessIp ;
  private long   startTime ;
  private long   currentTime ;
  private long   duration ;
  private long   accessCounter ;
  
  public UserActivitiesLogDataImpl() {}
  
  /**
   * @hibernate.id  generator-class="assigned" unsaved-value="null"
   ***/
  public String getSessionId() { return sessionId ; }
  public void   setSessionId(String s) { sessionId = s ; }
  
  /**
   * @hibernate.property
   ***/
  public String getUserName() { return userName ; }
  public void   setUserName(String s) { userName = s ; }
  
  /**
   * @hibernate.property
   ***/
  public String getPortalOwner() { return portalOwner ; }
  public void   setPortalOwner(String s) { portalOwner = s ; }
  
  /**
   * @hibernate.property
   ***/
  public long getStartTime() { return startTime ; }
  public void setStartTime(long l) { startTime =  l ; }
  
  /**
   * @hibernate.property
   ***/
  public String getAccessIp() { return accessIp ; }
  public void   setAccessIp(String s) { accessIp =  s ; }
  
  /**
   * @hibernate.property
   ***/
  public long   getDuration() { return duration ; }
  public void   setDuration(long l) { duration =  l ; }
  
  /**
   * @hibernate.property
   ***/
  public long    getAccessCounter() { return accessCounter ; }
  public void   setAccessCounter(long i) { accessCounter = i ; }
  
  public long   getCurrentTime() { return currentTime ; }
  public void   setCurrentTime(long l) { currentTime = l ; }
  
  public float  getDurationInMinute() { return duration / 60000 ; }
  
  synchronized public void logUserActivities(String id, String name, String owner, long start, String ip) {
    sessionId   = id ;
    userName    = name ;
    portalOwner = owner ;
    startTime   = start ;
    accessIp    = ip ;
    duration    = 0 ;
    accessCounter = 1 ;     
  }
  
  public String getTimeSlot() {
    GregorianCalendar calendar = new GregorianCalendar() ;
    calendar.setTimeInMillis(startTime) ;
    String timeSlot = String.valueOf(calendar.get(GregorianCalendar.DATE)) + "-" + 
                      String.valueOf(calendar.get(GregorianCalendar.MONTH) + 1) + "-" +
                      String.valueOf(calendar.get(GregorianCalendar.YEAR)) + " / " +
                      String.valueOf(calendar.get(GregorianCalendar.HOUR_OF_DAY)) + ":" +
                      String.valueOf(calendar.get(GregorianCalendar.MINUTE)) + ":" +
                      String.valueOf(calendar.get(GregorianCalendar.SECOND)) ;
    return timeSlot ;
  }
  synchronized public void update(long curTime) {
    currentTime = curTime ;
    duration      = curTime - startTime ;
    accessCounter ++ ; 
  }
  
  synchronized public void merge(UserActivitiesLogDataImpl other) {
    duration += other.getCurrentTime() - startTime ;
    accessCounter += other.getAccessCounter() ;
  }
}