/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portal;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.conditiongroovy.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class AddPortletSuite extends WebUnitSuite {
  public AddPortletSuite(String portletname) {
    super("AddPortletSuite", "Add a portlet into page") ;      
    //-----Expand content category---------    
    addWebUnit(
      new ClickURLLinkUnit("ClickOnContentCategory", "Expand content category").
      setURL("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=content").      
      addCondition(new NoLinkWithURLCondition("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId=content/${portletname}")).
      addValidator(new ExpectTextValidator("${portletname}"))
    ) ;           
    //-----Seclect a portlet in expanded content category---------
    addWebUnit(
      new ClickURLLinkUnit("Select${portletname}", "Select the a portlet").      
      setURL("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId=content/${portletname}").
      addValidator(new ExpectLinkWithURLValidator("componentId=${portletname}&portal:windowState=minimized")).        
      addValidator(new ExpectLinkWithURLValidator("componentId=${portletname}&portal:windowState=maximized"))
    ) ;
  }
}