/**************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved. *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.test.portal;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.CommonUnit;
import org.exoplatform.test.portlet.Account.*;
import org.exoplatform.test.portlet.Login.*;

/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: CustomizationSuite.java,v 1.2 2004/10/21 15:21:49 tuan08 Exp $
 **/
public class CustomizationSuite extends WebUnitSuite {
  
  public CustomizationSuite() {
    super("CutomizePortalSuite", "Add and edit in the the portal") ;
    // add a new page node
//    PageUnit.addCreateNewPage(this, "/", "newNode") ;
    addWebUnit(CommonUnit.CLICK_EDIT_PAGE_MODE) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickAddContainer", "Tell the web client click on add portlet").
        setURL("portal:action=addContainer").
        setBlockId("page-customizable-block")
    ) ;
    addWebUnit(
        new SubmitFormUnit("CreateNewContainer", "submit the form with values to create new container").
        setFormName("containerForm").
        setField(WebUnit.ACTION ,"save").
        setField("id", "NewContainer").
        setField("renderer", "ContainerColumnRenderer").
        setField("style","default").
        addValidator(new ExpectBlockValidator("NewContainer-customizable-block"))
    );
    //edit container properties 
    addWebUnit(
        new ClickURLLinkUnit("ClickEditContainer", "Edit the container properties").
        setURL("portal:action=editProperty").
        setBlockId("NewContainer-customizable-block")
    ) ;
    addWebUnit(
        new SubmitFormUnit("UpdateContainer", "submit the form with the new property values").
        setFormName("containerForm").
        setField(WebUnit.ACTION ,"save").
        setField("id", "OuterContainer").
        setField("renderer", "ContainerRowRenderer").
        setField("style","exo").
        addValidator(new ExpectBlockValidator("OuterContainer-customizable-block"))
    );
    //add container into the new container
    addWebUnit(
        new ClickURLLinkUnit("ClickAddContainer", "Tell the web client click on add portlet").
        setURL("portal:action=addContainer").
        setBlockId("OuterContainer-customizable-block")
    ) ; 
    addWebUnit(
        new SubmitFormUnit("CreateNewContainer", "submit the form with values to create new container").
        setFormName("containerForm").
        setField(WebUnit.ACTION ,"save").
        setField("id", "NewContainer").
        setField("renderer", "ContainerColumnRenderer").
        setField("style","default").
        addValidator(new ExpectBlockValidator("NewContainer-customizable-block"))
    );
    //add the first portlet  into the new created container
    addWebUnit(
        new ClickURLLinkUnit("ClickAddPortlet", "Tell the web client click on add portlet").
        setURL("portal:action=addPortlet").
        setBlockId("NewContainer-customizable-block")
    ) ;
   
   	addWebUnit(
   		new ClickURLLinkUnit("CollapseTheFirstCategory", "Hide the portlets in the first application category").
      setURL("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=")
    ) ;
    
    addWebUnit(
   		new ClickLink("ExpandContentApplication" , "Show the portlets in the content application").
      setTextLink("content")
    ) ;
                      
    addWebUnit(
      new ClickURLLinkUnit("ClickSelectPortlet", "Select the first portlet (forum portlet)").
      setURL("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId").
      addValidator(new ExpectBlockValidator("DisplayStaticContent"))
    ) ;
    // edit portlet properties 
    addWebUnit(
        new ClickURLLinkUnit("ClickEditPortlet", "Edit the portlet properties").
        setURL("portal:action=editProperty").
        setBlockId("DisplayStaticContent-customizable-block").
        addValidator(new ExpectFormNameValidator("portletForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("UpdatePortletProperties", "submit the form with the new property values").
        setFormName("portletForm").
        setField(WebUnit.ACTION ,"save").
        setField("id", "portlet1").
        setField("style", "exo-content").
        addValidator(new ExpectBlockValidator("portlet1-customizable-block"))
    );
    
    // add the second portlet  into the new created container
    addWebUnit(
        new ClickURLLinkUnit("ClickAddPortlet", "Tell the web client click on add portlet").
        setURL("portal:action=addPortlet").
        setBlockId("NewContainer-customizable-block")
    ) ;
    
    addWebUnit(
      new ClickURLLinkUnit("ClickSelectPortlet", "Select the first portlet (forum portlet)").
      setURL("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId").
      addValidator(new ExpectBlockValidator("DisplayStaticContent"))
    ) ;
    
    addWebUnit(
        new ClickURLLinkUnit("SaveChange", "Commit changes").
        setURL("uicomponent=UIToolbarPage&op=savePage").
        addValidator(new ExpectLinkWithURLValidator("portal:componentId=portlet1&portal:portletMode=edit"))
    ) ;
    
    // delete portlet  
    addWebUnit(
        new ClickURLLinkUnit("ClickDeletePortlet", "delete the first added portlet").
        setURL("portal:action=delete").
        setBlockId("portlet1-customizable-block").
        addValidator(new ExpectBlockValidator("portlet1", 0))
    ) ;
    
    //  delete container
    addWebUnit(
        new ClickURLLinkUnit("ClickDeleteContainer", "Delete the container").
        setURL("portal:action=delete").
        setBlockId("OuterContainer-customizable-block").
        addValidator(new ExpectBlockValidator("OuterContainer", 0)).
        addValidator(new ExpectBlockValidator("NewContainer", 0)).
        addValidator(new ExpectBlockValidator("FileExplorer", 0))
    ) ;
    //add portlet to page
    addWebUnit(
        new ClickURLLinkUnit("ClickAddPortlet", "click on add portlet").
        setURL("portal:action=addPortlet").
        setBlockId("page-customizable-block")
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickSelectPortlet", "Select the first available portlet(Forum)").
        setURL("uicomponent=UIPortletSelecttor&op=selecPortlet")
    ) ;
  }
  
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return   [ new NewAccountSuite("http://localhost:8080/portal"), 
               new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }
}
