/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portal;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.conditiongroovy.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class SearchPageRefSuite extends WebUnitSuite {
  public SearchPageRefSuite(String formId, String searchtype, String owner, String pagename) {
    super("SearchPageRefSuite", "Search and select a page") ;
   
    addWebUnit(
        new SubmitFormUnit("ClickSearchPageReference", "Click search page link").
        setFormId(formId).
        setField("op",searchtype).
        addValidator(new ExpectFormIdValidator("searchForm")).
        addValidator(new ExpectTextValidator("owner")) 
    ) ;    
    
    addWebUnit(
        new ClickURLLinkUnit("Select'TestPage'", "Select 'TestPage' ").
        setURL("uicomponent=UIPageList&op=select&objectId=${owner}:${pagename}").
        addValidator(new ExpectFormIdValidator(formId)).
        addValidator(new ExpectTextValidator("${owner}:${pagename")) 
      ) ;
     
  }
}