/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portlet.Organization ;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.conditiongroovy.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.portlet.Account.*;
import org.exoplatform.test.portlet.Login.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Nov 15, 2005
 */
public class OrganizationPortletSuite extends WebUnitSuite {
  static String DESC = "Go to Organization Portlet, then test three pages in Organization" ;
  static String NAME = "OrganizationPortletSuite" ;
  public OrganizationPortletSuite() {
    super(NAME, DESC) ;        
    addWebSuite(new UsersManagementSuite("/Site Map/Management", "/Site Map/User Registration")) ;
    addWebSuite(new GroupManagementSuite("/Site Map/Management", "/Site Map/User Registration")) ;
    addWebSuite(new MembershipManagementSuite("/Site Map/Management", "/Site Map/User Registration")) ;    
  }
  public OrganizationPortletSuite(String path, String reg_path) {
    super(NAME, DESC) ;    
    addWebSuite(new UsersManagementSuite(path, reg_path)) ;
    addWebSuite(new GroupManagementSuite(path, reg_path)) ;
    addWebSuite(new MembershipManagementSuite(path, reg_path)) ;   
  }
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite("admin", "exo", roles)] ;
  }
}
