/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portal;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.conditiongroovy.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.portlet.Login.*;

/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class EditPageSuite extends WebUnitSuite {
  public EditPageSuite() {
    super("EditPageSuite", "Modify a page ") ;
    //On Page
    //-----Add a new portlet    
    addWebUnit(
        new ClickURLLinkUnit("AddPortlet(onPage)", "tell web client click'addPortlet' on page").
        setURL("componentId=page&portal:action=addPortlet")        
    ) ;
    addWebSuite(new AddPortletSuite("DisplayStaticContent")) ; 
    //-----Add a new parent container
    addWebUnit(
        new ClickURLLinkUnit("AddParentContainer(onPage)", "Tell web client click 'AddContainer' on this page").
        setURL("componentId=page&portal:action=addContainer")        
    ) ;
    addWebSuite(new CreateEditContainerSuite("containerForm","NewParentContainer","NewParentContainer",
                                          "ContainerColumnRenderer","default")) ;    
    //-----Edit page properties
    addWebUnit(
        new ClickURLLinkUnit("EditPagePropertie", "Tell web client click 'EditPageProperties' on this page").
        setURL("componentId=page&portal:action=editProperty")
    ) ;       
    addWebSuite(new SearchPermissionSuite("pageForm","View",
                                          "PhaseId[1].searchGroupForViewPerm","*","user"));    
    addWebSuite(new SearchPermissionSuite("pageForm","Edit",
                                           "PhaseId[1].searchGroupForEditPerm", "owner" ,"user"));
    addWebUnit(
        new SubmitFormUnit("UpdatePageContainer", "submit the page's form with the new property values").
        setFormId("pageForm").        
        setField("title", "Edited Page").
        setField("renderer", "PageColumnRenderer").
        setField("decorator","default").
        setField("op","save").
        addValidator(new ExpectTextValidator("Edited Page"))
    );
    //On Parent Container
    //-----Add a new portlet
    addWebUnit(
        new ClickURLLinkUnit("AddPortlet(onParentCon)", "tell web client click'addPortlet' on parent container").
        setURL("componentId=NewParentContainer&portal:action=addPortlet")    
    ) ;
    addWebSuite(new AddPortletSuite("SearchPortlet")) ;
    //-----Edit portlet
    addWebSuite(new EditPortletSuite("SearchPortlet")) ;    
    //-----Edit parent container properties    
    addWebUnit(
        new ClickURLLinkUnit("EditParentContainer", "Tell web client click 'EditContainerProperties' on ParentContainer").
        setURL("componentId=NewParentContainer&portal:action=editProperty")        
    ) ;
    addWebSuite(new CreateEditContainerSuite("containerForm","ParentContainer",
                                               "Parent Container","default","default")) ;
    //-----Add a new child container
    addWebUnit(
        new ClickURLLinkUnit("AddChildContainer(onParentCon)", "Tell web client click 'AddContainer' on ParentContainer").
        setURL("componentId=ParentContainer&portal:action=addContainer")
    ) ;    
    addWebSuite(new CreateEditContainerSuite("containerForm","NewChildContainer",
                                              "Child Container","ContainerColumnRenderer","default")) ;
    //Delete on Parent Container
    //-----Delete Portlet
    addWebUnit(
        new ClickURLLinkUnit("DeletePortlet(onParentCon)", "delete the parentContainer's added portlet").
        setURL("componentId=SearchPortlet&portal:action=delete").
        addValidator(new ExpectNoTextValidator("SearchPortlet"))
    ) ;    
    //Delete on Page
    //-----Delete Parent Container
    addWebUnit(
        new ClickURLLinkUnit("DeleteParentContainer", "Delete the ParentContainer").
        setURL("componentId=ParentContainer&portal:action=delete")
    ) ;
    //-----Delete Portlet    
    addWebUnit(
        new ClickURLLinkUnit("DeletePortlet(onPage)", "delete the page's added portlet").
        setURL("componentId=DisplayStaticContent&portal:action=delete").
        addValidator(new ExpectNoTextValidator("DisplayStaticContent"))
    ) ;    
    }  
}