/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portlet.Forum ;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.conditiongroovy.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.portlet.Login.*;

/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: ForumPortletSuite.java,v 1.3 2004/10/21 15:21:49 tuan08 Exp $
 **/
static public class  ForumPortletAdminSuite extends WebUnitSuite {
  public ForumPortletAdminSuite() {
    super("ForumAdminSuite", "Go to forum page and do some admin actions") ;
    goToPage("/Site Map") ;
    addWebUnit(
      new ClickLinkWithText("Site Map", "A forum link and ignore the rest").
      setTextLink("Site Map").
      addCondition(new HaveLinkWithTextCondition("Forum", WebUnitSuite.IGNORE_STATUS))
    ) ;
    goToPage("/Forum") ;
    addWebUnit(
      new ClickURLLinkUnit("ClickForumConfigMode", "Click on the config mode of the forum portlet").
      setURL("portal:componentId=forum&portal:portletMode=config").
      setBlockId("forum")
    ) ;
    //Config Page
      addWebUnit(
        new ClickURLLinkUnit("DeleteForumCategory", "Delete old category if exists").
        setURL("uicomponent=UIAdminViewCategories&op=deleteCategory").
        addCondition(new HaveLinkWithURLCondition("uicomponent=UIAdminViewCategories&op=deleteCategory"))
      ) ; 
    addWebUnit(
      new ClickLinkWithText("ClickNewCategory", "Click New Category Link").
      setTextLink("New Category").
      addValidator(new ExpectFormIdValidator("categoryForm"))
    ) ;
    //-----Submit category form to create a new category-----
    addWebUnit(
      new SubmitFormUnit("SubmitCategroryForm", "Fill the  category information and submit").
      setFormId("categoryForm").
      setField("categoryName", "Exo Announcement").
      setField("categoryDesc", "for exo news").
      setField("order", "0").
      setField("op","save").
      addValidator(new ExpectTextValidator("Exo Announcement"))
    ) ;
    //Config Page
    addWebUnit(
      new ClickURLLinkUnit("ClickAddForum", "Add new forum").
      setURL("uicomponent=UIAdminViewCategories&op=addForum").
      addValidator(new ExpectFormIdValidator("forumForm"))
    ) ;
    //-----Submit Forum form to create a new forum---------------------------
    addWebUnit(
      new SubmitFormUnit("SubmitForumForm", "Fill the  forum information and submit").
      setFormId("forumForm").
      setField("forumName", "Exo Release News").
      setField("forumDesc", "for exo news, and release information").
      setField("viewForumRole","guest").
      setField("createTopicRole","guest").
      setField("replyTopicRole","guest").
      setField("moderators","admin").
      setField("order","0").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIAdminViewCategories&op=addForum"))
    ) ;
    //Config Page
    addWebUnit(
    	new ClickLinkWithText("ClickSelectCategory" , "selectCategory").
    	setTextLink("Exo Announcement").
    	addValidator(new ExpectLinkWithTextValidator("Exo Release News",0))
    ) ;
    //-----Click edit to edit category 
    addWebUnit(
      new ClickURLLinkUnit("ClickEditCategory" , "EditCategory").
      setURL("uicomponent=UIAdminViewCategories&op=editCategory").
      addValidator(new ExpectFormIdValidator("categoryForm"))
    ) ;
    //--------------Submit edit category form to edit a category
    addWebUnit(
      new SubmitFormUnit("SubmitEditCategoryForm", "Tell the web client submit the edit category form").
      setFormId("categoryForm").
      setField("op","save").
      setField("categoryName","Exo Announcement Edit").
      setField("categoryDesc","for exo news").
      addValidator(new ExpectLinkWithTextValidator("Exo Announcement Edit"))
    ) ;
    //Click forum view mode to come back view mode
    addWebUnit(
      new ClickURLLinkUnit("ClickForumViewMode", "Click on the view mode of the forum portlet").
      setURL("portal:componentId=forum&portal:portletMode=view").
      setBlockId("forum")
    ) ;
    //View Forum Page
    addWebUnit(
      new ClickLinkWithText("ClickForum", "Click on 'Exo Release News' Forum").
      setTextLink("Exo Release News").
      addValidator(new ExpectImageWithAltTextValidator("new topic"))
    ) ;
    //-----Click new topic icon-----
    addWebUnit(
      new ClickImageLinkWithAltTextUnit("ClickNewTopic", "Click on New Topic link").
      setAltText("new topic").
      addValidator(new ExpectFormIdValidator("postForm")) 
    ) ; 
    //--------Submit post form to create a new topic----------
    addWebUnit(
      new SubmitFormUnit("SubmitPostForm", "Tell the web client submit the post").
      setFormId("postForm").
      setField("op","save").
      setField("subject","new subject").
      setField("message","test message").
      addValidator(new ExpectTextValidator("new subject"))
    ) ;
    //----------View Topic---------
    addWebUnit(
      new ClickLinkWithText("ClickForumTopics", "Click on forum 'Exo Release News' topics").
      setTextLink("Exo Release News").
      addValidator(new ExpectLinkWithTextValidator("new subject"))
    ) ;
    addWebUnit(
      new ClickLinkWithText("ClickViewPost", "Click on forum 'new subject' post").
      setTextLink("new subject").
      addValidator(new ExpectTextValidator("new subject")).
      addValidator(new ExpectLinkWithTextValidator("Exo Release News"))
    ) ;
    //----------Click quote icon-----------
    addWebUnit(
      new ClickURLLinkUnit("ClickQuotePost", "Click on the quote post of 'new subject' post").
      setURL("uicomponent=UIPosts&op=quotePost").
      addValidator(new ExpectFormIdValidator("postForm"))
    ) ;
    //---------------Submit quote post form----------------
    addWebUnit(
      new SubmitFormUnit("SubmitQuotePostForm", "Tell the web client submit the post quote").
      setFormId("postForm").
      setField("op","save").
      setField("subject","new subject").
      setField("message","test message edit").
      addValidator(new ExpectTextValidator("test message")).
      addValidator(new ExpectTextValidator("test message edit"))
    ) ;
    //---------Click edit icon-----------
    addWebUnit(
      new ClickURLLinkUnit("ClickEditPost", "Click on the quote post of 'new subject' post").
      setURL("uicomponent=UIPosts&op=editPost").
      addValidator(new ExpectFormIdValidator("postForm")).
      addValidator(new ExpectTextValidator("Add/Edit Post"))
    ) ;
    //---------------Submit edit post form to edit a topic------------
    addWebUnit(
      new SubmitFormUnit("SubmitEditPostForm", "Tell the web client submit the post edit").
      setFormId("postForm").
      setField("op","save").
      setField("subject","old subject").
      setField("message","test message edit").
      addValidator(new ExpectTextValidator("old subject")).
      addValidator(new ExpectTextValidator("test message edit"))
    ) ;
    //----------Click forum topics------------------
    addWebUnit(
      new ClickLinkWithText("ClickForumTopics", "Click on forum 'Exo Release News' topics").
      setTextLink("Exo Release News").
      addValidator(new ExpectLinkWithTextValidator("new subject"))
    ) ;
    //-----Click delete topic----------
    addWebUnit(
    	new ClickImageLinkWithAltTextUnit("ClickDeleteTopic", "Click on 'de' to delete the new topic").
      setAltText("delete").
      setBlockId("forum").
      addValidator(new ExpectNoTextValidator("new subject")).
      addValidator(new ExpectNoTextValidator("old subject"))
    ) ; 
    //------Click 'forum index'
    addWebUnit(
      new ClickLinkWithText("ClickForumIndex", "Click on forum 'Forum Index' topics").
      setTextLink("Forum Index").
      addValidator(new ExpectLinkWithTextValidator("Exo Announcement Edit")).
      addValidator(new ExpectLinkWithTextValidator("Exo Release News"))
    ) ;
    //View Forum Page
    addWebUnit(
      new ClickURLLinkUnit("ClickForumViewMode", "Click on the view mode of the forum portlet").
      setURL("portal:componentId=forum&portal:portletMode=config").
      setBlockId("forum")
    ) ;
    //Config Page
//    addWebUnit(
//      new ClickURLLinkUnit("DeleteForumCategory", "Delete old category if exists").
//      setURL("uicomponent=UIAdminViewCategories&op=deleteCategory").
//      addCondition(new HaveLinkWithURLCondition("uicomponent=UIAdminViewCategories&op=deleteCategory"))
//    ) ; 
  }
  
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite("admin", "exo", roles)] ;
  }
}