/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.conditiongroovy;

import org.exoplatform.test.web.ExoWebClient;
import org.exoplatform.test.web.WebUnitSuite;
import org.exoplatform.test.web.Util;
import com.meterware.httpunit.*;
import org.exoplatform.test.web.condition.Condition;

/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: HaveLinkWithURLCondition.java,v 1.1 2004/10/11 23:36:04 tuan08 Exp $
 **/
public class HaveLinkWithURLCondition implements Condition {
  private String partOfURL_ ;
  private int suiteStatus_ ;
  
  public HaveLinkWithURLCondition(String text) {
    partOfURL_ = text ;
    suiteStatus_ = -1 ;
  }
  
  public HaveLinkWithURLCondition(String text, int status) {
    partOfURL_ = text ;
    suiteStatus_ = status ;
  }
  
  public boolean checkCondition(WebResponse response, WebTable block, ExoWebClient client){
    WebLink link = Util.findLinkWithURL(response, block,partOfURL_) ;
    boolean test =  link != null ;
    if(test == false && suiteStatus_ >= 0) {
      client.getTestSuites().getCurrentWebUnitSuite().setStatus(suiteStatus_) ;
    }
    return test ;
  }
  
  public String getName() { return "HaveLinkWithURLCondition" ; }
  public String getDescription() {
    return "This unit test should run only if the previous return response has the link with url" ;
  }
}