/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.conditiongroovy;

import org.exoplatform.test.web.ExoWebClient;
import com.meterware.httpunit.*;
import org.exoplatform.test.web.condition.Condition;

/**
 * May 21, 2004
 * @author: Dung Hoang
 * @email:   jobdung@yahoo.com
 * @version: $Id: NoLinkWithTextCondition.groovy,v 1.1 2005/12/21 2:38:04 dunghoang Exp $
 **/
public class HaveRoleCondition implements Condition {
  private String role_ ;
  
  public HaveRoleCondition(String role) {
    role_ = role ;
  }
  
  public boolean checkCondition(WebResponse response, WebTable block, ExoWebClient client){
    return client.getRoles().containsKey(role_) ;
  }
  
  public String getName() { return "HaveRoleCondition" ; }
  public String getDescription() {
    return "This unit test should run only if the remote user has the role" ;
  }
}