/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.conditiongroovy;

import org.exoplatform.test.web.ExoWebClient;
import com.meterware.httpunit.*;
import org.exoplatform.test.web.condition.Condition;

/**
 * Dec 22, 2005
 * @author: Dung Hoang
 * @email:   jobdung@yahoo.com
 * @version: $Id: NoLinkWithURLCondition.groovy,v 1.1 2005/12/22 10:13:04 dunghoang Exp $
 **/
public class NoRoleCondition implements Condition {
  private String role_ ;
  
  public NoRoleCondition(String role) {
    role_ = role ;
  }
  
  public boolean checkCondition(WebResponse response, WebTable block, ExoWebClient client){
    return !client.getRoles().containsKey(role_) ;
  }
  
  public String getName() { return "NoRoleCondition" ; }
  public String getDescription() {
    return "This unit test should run only if the remote user do not have the role" ;
  }
}