package org.exoplatform.test.portlet.Account;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.* ;
import org.exoplatform.test.web.validator.*;

public class AccountUnit extends WebUnitSuite{    
  static WebUnit createBlankNewAccountUnit() {
    WebUnit unit =
      new SubmitFormUnit("BlankAccount", "All fields are blank").
      setFormId("accountForm").
      setField("username", "").
      setField("password1x", "").
      setField("password2x", "").
      setField("firstname", "").
      setField("lastname", "").
      setField("email", "").
      setField("op", "save").     
      addValidator(new ExpectTextValidator("The field \"username\" cannot be empty")).      
      addValidator(new ExpectTextValidator("You forgot to enter the field \"password1x")).
      addValidator(new ExpectTextValidator("You forgot to enter the field \"password2x")).      
      addValidator(new ExpectTextValidator("You forgot to enter the field \"firstname")).      
      addValidator(new ExpectTextValidator("You forgot to enter the field \"lastname")).
      addValidator(new ExpectTextValidator("You have entered \"\" in field email, it is an invalid email address"))
    return unit ;
  }
  static WebUnit createNotSamePasswordAccount(String userName , String password1x, String password2x) {
    WebUnit unit =
      new SubmitFormUnit("NotSamePasswordAccount", "Two password are not same").
      setFormId("accountForm").
      setField("username", userName).
      setField("password1x", password1x).
      setField("password2x", password2x).
      setField("firstname", userName).
      setField("lastname", userName).
      setField("email", "user@localhost.net").
      setField("op", "save").     
      addValidator(new ExpectTextValidator("password fields cannot be empty and must be the same value"))      
    return unit ;
  }
  static WebUnit createInvalidEmailAccount(String userName , String password, String email) {
    WebUnit unit =
      new SubmitFormUnit("InvalidEmailAccount", "email is invalid").
      setFormId("accountForm").
      setField("username", userName).
      setField("password1x", password).
      setField("password2x", password).
      setField("firstname", userName).
      setField("lastname", userName).      
      setField("email", email).
      setField("op", "save").     
      addValidator(new ExpectTextValidator("You have entered \"${email}\" in field email, it is an invalid email address"))      
    return unit ;
  }  
  static WebUnit createNewAccountUnit(String userName , String password) {
    WebUnit unit = 
      new SubmitFormUnit("CreateNewAccount", "Create exoplatform account").
      setFormId("accountForm").
      setField("username", userName).
      setField("password1x", password).
      setField("password2x", password).
      setField("firstname", userName).
      setField("lastname", userName).
      setField("email", "user@localhost.net").
      setField("op","save").
      addValidator(new ExpectTextValidator("New user has been created")) ;
    return unit ;
  }  
}
