/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portlet.FileExplorer;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.portlet.Login.*;


/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: FileExplorerPortletUserSuite.java,v 1.1 2004/10/11 23:27:28 tuan08 Exp $
 **/
public class FileExplorerPortletAdminSuite  extends WebUnitSuite {
  
  public FileExplorerPortletAdminSuite() {
    super("FileExplorerAdminSuite", "Go to File Explorer and test the admin actions") ;
    goToPage("/Site Map/File Explorer") ;
    addWebUnit(
        new ClickURLLinkUnit("GotoAdminTab", "Go To Admin Tab").
        setURL("uicomponent=UINode&op=selectTab&tabId=UIAdmin").
        setBlockId("file-explorer").
        addValidator(new ExpectTextValidator("Remove This File Or Directory"))
    );
  //  addWebUnit(
  //      new ClickURLLinkUnit("GotoEditorTab", "Go to editor tab").
  //      setURL("uicomponent=UIAdmin&op=selectTab&tabId=UINodeEditor").
  //      setBlockId("file-explorer").
  //      addValidator(new ExpectFormIdValidator("uploadForm"))
  //  );
    addWebUnit(
        new ClickURLLinkUnit("GotoPropertiesTab", "Go to the properties tab").
        setURL("uicomponent=UIAdmin&op=selectTab&tabId=UIFileNodeInfo").
        setBlockId("file-explorer").
        addValidator(new ExpectTextValidator("Remove This File Or Directory"))
    );
    
    addWebUnit(
        new ClickURLLinkUnit("GotoViewTab", "Go Back To List children tab").
        setURL("uicomponent=UINode&op=selectTab&tabId=UINodeContent").
        setBlockId("file-explorer")
    );
    
  //  addWebUnit(
  //      new ClickURLLinkUnit("ClickIndexFile", "Click on the file  	index.html").
  //      setURL("op=changeNode&objectId=/index.html").
  //      setBlockId("file-explorer").
  //      addValidator(new ExpectTextValidator(""))
  //  );
    
    addWebUnit(
       new ClickURLLinkUnit("GotoAdminTab", "Go To Admin Tab").
       setURL("uicomponent=UINode&op=selectTab&tabId=UIAdmin").
       setBlockId("file-explorer").
       addValidator(new ExpectTextValidator("Remove This File Or Directory"))
    );
    
  // addWebUnit(
  //     new ClickURLLinkUnit("GotoEditorTab", "Go to editor tab").
  //     setURL("uicomponent=UIAdmin&op=selectTab&tabId=UINodeEditor").
  //     setBlockId("file-explorer").
  //     addValidator(new ExpectFormIdValidator("contentForm"))
  //  );
    
  // addWebUnit(
  //     new SubmitFormUnit("SubmitSaveContentForm", "Try To save the current content").
  //     setFormId("contentForm").
  //     setField("op","saveContent").
  //     addValidator(new ExpectTextValidator("info: Your file has been saved successfully."))
  //  ) ;
  }
  
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite("admin", "exo", roles)] ;
  }
}