/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package control;

import java.util.Map ;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.test.web.* ;
import org.exoplatform.test.web.servlet.* ;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Dec 21, 2005
 */
public class RunTest extends ActionHandler {
  private String DEFAULT_SUITE = "org.exoplatform.test.portlet.Login.UserLoginSuite" ;
  
  public void execute(HttpServletRequest request, HttpServletResponse response) {
    ResourceManager resManager = getResourceManager() ;
    Map  binding =  resManager.createDefaultBinding(request) ;
    String subaction = request.getParameter("subaction") ;
    def config = getConfiguration() ;
    def client = config.getWebClient() ;
    def  suites = client.getTestSuites() ;
    if(suites == null) {
      suites = config.getTestSuites(resManager, DEFAULT_SUITE) ;
      client.setSuites(suites) ;
    }
    if("nextUnit".equals(subaction)) {
      if(suites.nextUnit()) {
        client.executeUnit(suites.getCurrentWebUnit()) ;
        binding.put("resultData", client.getResponseText());
      } else {
        binding.put("resultData", "test reach the end, click  reset to rerun the test");
      }
      resManager.merge(response.getWriter(), "templates/result.groovy", binding);
    } else if("reset".equals(subaction)) {
      suites.reset()  ;
    } else if("showSuiteSummary".equals(subaction)) {
      binding.put("resultData", suites.getHtmlSummary());
      resManager.merge(response.getWriter(), "templates/result.groovy", binding);
    } else if("showUnitResult".equals(subaction)) {
      binding.put("resultData", client.getResponseText());
      resManager.merge(response.getWriter(), "templates/result.groovy", binding);
    } else if("showUnitSummary".equals(subaction)) {
      def unit = suites.getCurrentWebUnit() ;
      if(unit != null) {
        binding.put("resultData", unit.getUnitSummaryInXHTML());
      } else {
        binding.put("resultData", "NO UNIT IS SELECTED");
      }
      resManager.merge(response.getWriter(), "templates/result.groovy", binding);
    }
  }
}