/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package control;

import java.util.Map ;
import java.util.HashMap ;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.test.web.* ;
import org.exoplatform.test.web.servlet.* ;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Dec 21, 2005
 */
public class SelectTest extends ActionHandler { 
  private Map availableTests_ ;
  
  public SelectTest() {
    availableTests_ = new HashMap() ;
    availableTests_.put("org.exoplatform.test.portlet.Login.UserLoginSuite",
                        "User Login Suite") ;
    availableTests_.put("org.exoplatform.test.portlet.Account.NewAccounSuite",
                        "New Account Suite") ;
    availableTests_.put("org.exoplatform.test/portlet.Organization.OrganizationPortletSuite",
                        "Organization Portlet Suite") ;
  }
  
  public void execute(HttpServletRequest request, HttpServletResponse response) {
    ResourceManager resManager = getResourceManager() ;
    Map  binding =  resManager.createDefaultBinding(request) ;
    String suite = request.getParameter("suite") ;
    if(suite != null) {
      def config = getConfiguration() ;
      def client = config.getWebClient() ;
      def suites = config.getTestSuites(resManager, suite) ;
      client.setSuites(suites) ;
      resManager.merge(response.getWriter(), "templates/control.groovy", binding);
    } else {
      binding.put("availableTests", availableTests_) ;
      resManager.merge(response.getWriter(), "templates/SelectTest.groovy", binding);
    }
  }
}