BUILD_EXO_PLATFORM="cd $EXO_SRC_CODE/exo-platform && mvn clean install"
BUILD_EXO_PORTAL="cd $EXO_SRC_CODE/exo-portal && mvn clean install"
BUILD_EXO_CMS="cd $EXO_SRC_CODE/exo-cms && mvn clean install"

CLEAN_PORTAL="cd $EXO_SRC_CODE/exo-platform && mvn clean &&
              cd $EXO_SRC_CODE/exo-portal && mvn clean"

CLEAN_CMS="$CLEAN_PORTAL && cd $EXO_SRC_CODE/exo-cms && mvn clean"

CLEAN_GROUPWARE="cd $EXO_SRC_CODE/exo-groupware && mvn clean"


alias ls="ls --color"

alias cdhome="cd ~"
alias cdwinhome="cd $USER_HOME"
alias cdback='cd  $OLDPWD'
alias cdv2x="cd $EXO_SRC_CODE"
alias cdexo-platform="cd $EXO_SRC_CODE/exo-platform"
alias cdexo-portal="cd $EXO_SRC_CODE/exo-portal"
alias cdexo-cms="cd $EXO_SRC_CODE/exo-cms"
alias cdexo-assembly="cd $EXO_SRC_CODE/exo-assembly"
alias cdexo-test="cd $EXO_SRC_CODE/exo-test"
alias cdbasedir="cd $BASE_DIRECTORY"
alias cdtomcat="cd $EXO_WORKING_DIR/exo-tomcat"
alias cdtomcatbin="cd $EXO_WORKING_DIR/exo-tomcat/bin"

alias mvnnewtomcat="cd $EXO_SRC_CODE/exo-assembly/portal && 
                    mvn exo:platform -Ddeploy=newTomcat && 
                    cdback"

alias mvndeploymodule="mvn clean install exo:module -Ddeploy=nodep"
alias mvncleaninstall="mvn clean install"

alias mvnbuildportal="$BUILD_EXO_PLATFORM && $BUILD_EXO_PORTAL &&
                      cd $EXO_SRC_CODE/exo-assembly/portal &&
                      mvn clean install exo:platform -Ddeploy=tomcat"

alias  mvncleanportal="$CLEAN_PORTAL"
                    

alias mvnbuildcms="$BUILD_EXO_PLATFORM && $BUILD_EXO_PORTAL &&  $BUILD_EXO_CMS &&
                   cd $EXO_SRC_CODE/exo-assembly/cms &&
                   mvn clean install exo:platform -Ddeploy=tomcat"

alias  mvncleancms="$CLEAN_CMS"
alias  mvncleanall="$CLEAN_CMS && CLEAN_GROUPWARE"

alias  svnupdatev2x="$CLEAN_PORTAL && 
                     cdv2x &&
                     svn update"

alias  svnModifiedFiles='svn st | grep "^M" '
alias  svnConflictFiles='svn st | grep "^C" '

alias vibuild="vi $USER_HOME/build.properties"
alias visetting="vi $USER_HOME/.m2/settings.xml"

alias sql="mysql -t -u dev -pdev dev"

alias ldap=" cd /cygdrive/c/openldap && ./slapd -d 1 "

alias tomcatClean="cd $EXO_WORKING_DIR/exo-tomcat/bin &&
                   rm -rf ../temp/* &&
                   rm -rf ../work/* &&
                   rm -rf ../logs/* "
   
alias tomcatRun="cd $EXO_WORKING_DIR/exo-tomcat/bin && chmod +x *.sh && ./exo-run.sh"

alias tomcatCleanRun="cd $EXO_WORKING_DIR/exo-tomcat/bin &&
		      rm -rf ../temp/* &&
                      rm -rf ../work/* &&
                      rm -rf ../logs/*  &&
                      chmod +x *.sh && ./exo-run.sh "

